<template>
  <odometro
    :loadingTitle="loadingTitle"
    :loadingContent="loadingContent"
    :titleNotFound="titleNotFound"
    :contentNotFound="contentNotFound"
    :data="data"
  />
</template>
<script>
import Odometro from "@/views/secure/sistema-informacion/dashboards/v2/disciplinas/components/graficas/Odometro.vue";
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-PorcentajePuntosVentaAprobadosImpl",
  props: ["filters"],
  components: {
    Odometro,
  },
  data() {
    return {
      loadingTitle: true,
      loadingContent: true,
      titleNotFound: false,
      contentNotFound: false,
      semaforo: null,
      semaforoUtils: null,
      data: {
        descripcion: null,
        color: null,
        total: null,
        totalValue: null,
        values: [{ leyeda: null, value: null }],
      },
    };
  },
  watch: {
    filters(val) {
      this.getData();
    },
    semaforoUtils(val) {
      this.setBarColor();
    },
  },
  methods: {
    getSemaforoRangos(semaforo) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          semaforo.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            semaforo.rangos = data.resultado.rangos;
            this.semaforoUtils = {
              getColor: this.getColorByValue,
            };
          }
        })
        .catch((error) => {});
    },
    getSemaforo(semaforoLocal) {
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" + semaforoLocal.idSemaforo
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforo = {
              ...semaforoLocal,
              ...data.resultado,
            };
            this.getSemaforoRangos(this.semaforo);
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.semaforo = {};
          } else {
            console.log(error);
          }
        });
    },
    getColorByValue(value) {
      let rango = this.semaforo.rangos.filter(
        (item) => item.limiteInferior <= value && item.limiteSuperior >= value
      );
      if (rango.length > 0) {
        return rango[0].color;
      } else {
        return null;
      }
    },
    getSemaforoDefectoGrafica(grafica) {
      axios(
        "/sistema-informacion/tablero/graficas/v1/" +
          grafica.idGrafica +
          "/semaforos/regla"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.semaforo = data.resultado;
            this.getSemaforo(this.semaforo);
          }
        })
        .catch((error) => {});
    },
    getGrafica() {
      axios(
        "/sistema-informacion/tablero/graficas/v1/clave/red-unica-porcentaje-puntos-venta-aprobados"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = Object.assign(this.data, data.resultado);
            this.getSemaforoDefectoGrafica(this.data);
          }
        })
        .catch((error) => {
          this.titleNotFound = true;
          console.log(error);
        })
        .finally(() => {
          this.loadingTitle = false;
        });
    },
    getData() {
      this.loadingContent = true;
      this.contentNotFound = false;
      axios
        .post(
          "/sistema-informacion/tablero/reportes/v1/disciplinas/" +
            this.filters.path.idDisciplina +
            "/red-unica/porcentaje-puntos-venta-aprobados/busquedas",
          this.filters.request
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            let porcentajePuntosVentaAprobados =
              data.resultado.porcentajePuntosVentaAprobados;
            this.data.values = [];
            porcentajePuntosVentaAprobados.forEach((element) => {
              this.data.total = element.porcentaje + "%";
              this.data.totalValue = element.porcentaje;
              this.data.values = [
                {
                  leyeda: "Puntos de venta aprobados:",
                  value: element.aprobados,
                },
              ];
            });
            this.setBarColor();
          }
        })
        .catch((error) => {
          this.contentNotFound = true;
          console.log(error);
        })
        .finally(() => {
          this.loadingContent = false;
        });
    },
    setBarColor() {
      if (this.semaforoUtils && this.data && this.data.totalValue) {
        this.data.color = this.semaforoUtils.getColor(this.data.totalValue);
      }
    },
  },
  created() {
    this.getGrafica();
  },
};
</script>
